#include <QtGui>


#include "mainwindow.h"

MainWindow::MainWindow()
{
    setObjectName(QString::fromUtf8("Calcul CAH"));
    centralwidget = new QWidget(this);
    centralwidget->setObjectName(QString::fromUtf8("centralwidget"));
    gridLayout = new QGridLayout(centralwidget);
    gridLayout->setSpacing(6);
    gridLayout->setMargin(9);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    poidBox = new QGroupBox(centralwidget);
    poidBox->setObjectName(QString::fromUtf8("poidBox"));
    gridLayout1 = new QGridLayout(poidBox);
    gridLayout1->setSpacing(6);
    gridLayout1->setMargin(9);
    gridLayout1->setObjectName(QString::fromUtf8("gridLayout1"));
    poidWidget = new QTableWidget(poidBox);
    poidWidget->setObjectName(QString::fromUtf8("poidWidget"));

    gridLayout1->addWidget(poidWidget, 0, 0, 1, 1);


    gridLayout->addWidget(poidBox, 4, 0, 1, 2);

    descrBox_2 = new QGroupBox(centralwidget);
    descrBox_2->setObjectName(QString::fromUtf8("descrBox_2"));
    gridLayout2 = new QGridLayout(descrBox_2);
    gridLayout2->setSpacing(6);
    gridLayout2->setMargin(9);
    gridLayout2->setObjectName(QString::fromUtf8("gridLayout2"));
    label_2 = new QLabel(descrBox_2);
    label_2->setObjectName(QString::fromUtf8("label_2"));

    gridLayout2->addWidget(label_2, 0, 0, 1, 1);

    spinBox_2 = new QSpinBox(descrBox_2);
    spinBox_2->setObjectName(QString::fromUtf8("spinBox_2"));

    gridLayout2->addWidget(spinBox_2, 0, 1, 1, 1);


    gridLayout->addWidget(descrBox_2, 3, 0, 1, 2);

    descrBox = new QGroupBox(centralwidget);
    descrBox->setObjectName(QString::fromUtf8("descrBox"));
    gridLayout3 = new QGridLayout(descrBox);
    gridLayout3->setSpacing(6);
    gridLayout3->setMargin(9);
    gridLayout3->setObjectName(QString::fromUtf8("gridLayout3"));
    label = new QLabel(descrBox);
    label->setObjectName(QString::fromUtf8("label"));

    gridLayout3->addWidget(label, 0, 0, 1, 1);

    spinBox = new QSpinBox(descrBox);
    spinBox->setObjectName(QString::fromUtf8("spinBox"));

    gridLayout3->addWidget(spinBox, 0, 1, 1, 1);


    gridLayout->addWidget(descrBox, 2, 0, 1, 2);

    spacerItem = new QSpacerItem(20, 231, QSizePolicy::Minimum, QSizePolicy::Expanding);

    gridLayout->addItem(spacerItem, 5, 0, 1, 1);

    critereBox = new QGroupBox(centralwidget);
    critereBox->setObjectName(QString::fromUtf8("critereBox"));
    gridLayout4 = new QGridLayout(critereBox);
    gridLayout4->setSpacing(6);
    gridLayout4->setMargin(9);
    gridLayout4->setObjectName(QString::fromUtf8("gridLayout4"));
    minButton = new QRadioButton(critereBox);
    minButton->setObjectName(QString::fromUtf8("minButton"));

    gridLayout4->addWidget(minButton, 0, 0, 1, 1);

    maxButton = new QRadioButton(critereBox);
    maxButton->setObjectName(QString::fromUtf8("maxButton"));

    gridLayout4->addWidget(maxButton, 1, 0, 1, 1);

    moyButton = new QRadioButton(critereBox);
    moyButton->setObjectName(QString::fromUtf8("moyButton"));

    gridLayout4->addWidget(moyButton, 2, 0, 1, 1);


    gridLayout->addWidget(critereBox, 1, 1, 1, 1);

    disanceBox = new QGroupBox(centralwidget);
    disanceBox->setObjectName(QString::fromUtf8("disanceBox"));
    gridLayout5 = new QGridLayout(disanceBox);
    gridLayout5->setSpacing(6);
    gridLayout5->setMargin(9);
    gridLayout5->setObjectName(QString::fromUtf8("gridLayout5"));
    eucliButton = new QRadioButton(disanceBox);
    eucliButton->setObjectName(QString::fromUtf8("eucliButton"));

    gridLayout5->addWidget(eucliButton, 0, 0, 1, 1);

    eucli2Button = new QRadioButton(disanceBox);
    eucli2Button->setObjectName(QString::fromUtf8("eucli2Button"));

    gridLayout5->addWidget(eucli2Button, 1, 0, 1, 1);


    gridLayout->addWidget(disanceBox, 1, 0, 1, 1);

    dataBox = new QGroupBox(centralwidget);
    dataBox->setObjectName(QString::fromUtf8("dataBox"));
    gridLayout6 = new QGridLayout(dataBox);
    gridLayout6->setSpacing(6);
    gridLayout6->setMargin(9);
    gridLayout6->setObjectName(QString::fromUtf8("gridLayout6"));
    loadButton = new QPushButton(dataBox);
    loadButton->setObjectName(QString::fromUtf8("loadButton"));

    gridLayout6->addWidget(loadButton, 0, 1, 1, 1);

    filenameEdit = new QLineEdit(dataBox);
    filenameEdit->setObjectName(QString::fromUtf8("filenameEdit"));

    gridLayout6->addWidget(filenameEdit, 0, 0, 1, 1);


    gridLayout->addWidget(dataBox, 0, 0, 1, 2);

    resultBox = new QGroupBox(centralwidget);
    resultBox->setObjectName(QString::fromUtf8("resultBox"));
    gridLayout7 = new QGridLayout(resultBox);
    gridLayout7->setSpacing(6);
    gridLayout7->setMargin(9);
    gridLayout7->setObjectName(QString::fromUtf8("gridLayout7"));
    resultBar = new QProgressBar(resultBox);
    resultBar->setObjectName(QString::fromUtf8("resultBar"));
    resultBar->setValue(24);
    resultBar->setOrientation(Qt::Horizontal);

    gridLayout7->addWidget(resultBar, 0, 0, 1, 1);

    calcButton = new QPushButton(resultBox);
    calcButton->setObjectName(QString::fromUtf8("calcButton"));

    gridLayout7->addWidget(calcButton, 0, 1, 1, 1);

    textEdit = new QTextEdit(resultBox);
    textEdit->setObjectName(QString::fromUtf8("textEdit"));

    gridLayout7->addWidget(textEdit, 1, 0, 1, 2);

    resultWidget = new QTreeWidget(resultBox);
    resultWidget->setObjectName(QString::fromUtf8("resultWidget"));

    gridLayout7->addWidget(resultWidget, 2, 0, 1, 2);


    gridLayout->addWidget(resultBox, 0, 2, 6, 1);

    setCentralWidget(centralwidget);

    setWindowTitle(QApplication::translate("MainWindow", "MainWindow", 0, QApplication::UnicodeUTF8));
    poidBox->setTitle(QApplication::translate("MainWindow", "Pond\303\251ration", 0, QApplication::UnicodeUTF8));
    descrBox_2->setTitle(QApplication::translate("MainWindow", "Pr\303\251cision", 0, QApplication::UnicodeUTF8));
    label_2->setText(QApplication::translate("MainWindow", "Chiffres apr\303\250s la virgule", 0, QApplication::UnicodeUTF8));
    descrBox->setTitle(QApplication::translate("MainWindow", "Description", 0, QApplication::UnicodeUTF8));
    label->setText(QApplication::translate("MainWindow", "Nombre de classes", 0, QApplication::UnicodeUTF8));
    critereBox->setTitle(QApplication::translate("MainWindow", "Crit\303\250re", 0, QApplication::UnicodeUTF8));
    minButton->setText(QApplication::translate("MainWindow", "Saut minimal", 0, QApplication::UnicodeUTF8));
    maxButton->setText(QApplication::translate("MainWindow", "Saut maximal", 0, QApplication::UnicodeUTF8));
    moyButton->setText(QApplication::translate("MainWindow", "Distance moyenne", 0, QApplication::UnicodeUTF8));
    disanceBox->setTitle(QApplication::translate("MainWindow", "Distance", 0, QApplication::UnicodeUTF8));
    eucliButton->setText(QApplication::translate("MainWindow", "Euclidienne", 0, QApplication::UnicodeUTF8));
    eucli2Button->setText(QApplication::translate("MainWindow", "Euclidienne carr\303\251e", 0, QApplication::UnicodeUTF8));
    dataBox->setTitle(QApplication::translate("MainWindow", "Donn\303\251es", 0, QApplication::UnicodeUTF8));
    loadButton->setText(QApplication::translate("MainWindow", "...", 0, QApplication::UnicodeUTF8));
    resultBox->setTitle(QApplication::translate("MainWindow", "R\303\251sultats", 0, QApplication::UnicodeUTF8));
    calcButton->setText(QApplication::translate("MainWindow", "Calculer", 0, QApplication::UnicodeUTF8));
    resultWidget->headerItem()->setText(0, QApplication::translate("MainWindow", "Cluster", 0, QApplication::UnicodeUTF8));
    resultWidget->headerItem()->setText(1, QApplication::translate("MainWindow", "Elements", 0, QApplication::UnicodeUTF8));
    resultWidget->headerItem()->setText(2, QApplication::translate("MainWindow", "Distance", 0, QApplication::UnicodeUTF8));


    QSize size(825, 640);
    size = size.expandedTo(this->minimumSizeHint());
    this->resize(size);

    eucliButton->setChecked(true);
    minButton->setChecked(true);
    resultBar->setValue(0);
    spinBox_2->setValue(2);
    textEdit->setLineWrapMode(QTextEdit::NoWrap);
    connect(loadButton, SIGNAL(clicked(bool)), this, SLOT(openData()));
    connect(calcButton, SIGNAL(clicked(bool)), this, SLOT(makeCAH()));
    QMetaObject::connectSlotsByName(this);

}

void MainWindow::openData()
{
	dataFile = QFileDialog::getOpenFileName(this);
	filenameEdit->setText(dataFile);

	QStringList rows = loadData().split('\n');
	if(rows.size()) {
		QStringList size = rows.at(0).split(" ");
		if(size.size() == 2) {
			uint width = size.at(0).toUInt();
			uint height = size.at(1).toUInt();
			resizePond(width);
			spinBox->setRange(1, height);
			spinBox->setValue(1);
		}
	}
}

QString MainWindow::loadData()
{
	QFile file(dataFile);
	if (!file.open(QFile::ReadOnly | QFile::Text)) {
		QMessageBox::warning(this, tr("MatrixEditor"),
				     tr("Impossible de lire %1:\n%2.").
				     arg(dataFile).arg(file.errorString()));
		return QString("");
	}

	QTextStream in(&file);

	return in.readAll();
}

bool MainWindow::testData(const QString & data) {
	QStringList rows = data.split('\n');
        QStringList first;
	int width, height;

        if(!rows.size())
                return false;

        first = rows.first().split(" ");
        rows.removeAt(0);

        if(first.size() != 2)
                return false;

	width = first.at(0).toUInt();
	height = first.at(1).toUInt();

	if(rows.size() < height)
		return false;

        for (int i = 0; i < height; ++i) {
                if(rows.at(i).split(";").size() != width)
			return false;
        }

	return true;
}

uint MainWindow::getDst()
{
	if(eucliButton->isChecked())
		return DST_EUCLI;
	else
		return DST_EUCLI2;
}

uint MainWindow::getPrec()
{
	return spinBox_2->value();
}

uint MainWindow::getCri()
{
	if(minButton->isChecked())
		return CRI_MIN;
	else if(maxButton->isChecked())
		return CRI_MAX;
	else
		return CRI_MOY;
}

QVector<double> MainWindow::getPond()
{
	QVector<double> result;

	for(int i = 0; i < poidWidget->columnCount (); ++i) {
		QTableWidgetItem *item = poidWidget->item(0, i);
		if(item)
			result << item->text().toDouble();
		else
			result << 1;
	}

	return result;
}

void MainWindow::makeCAH()
{
	uint step = spinBox->maximum() - spinBox->value();
	QString data = loadData();
	QStringList result;

	if(!testData(data)) {
		QMessageBox::warning(this, tr("MatrixEditor"),
				     tr("Format de donne incorect !"));
		return;
	}

	resultBar->setValue(0);

	CAH cah(data, getPond(), getDst(), getCri(), getPrec());

	result << cah.getData();

	for(uint i = 1; i <= step; ++i) {
		double perc = ceil(100. * (double) i / (double) step);
		result << cah.run();
		resultBar->setValue((int) perc);
	}
	textEdit->setText(result.join("\n"));
	makeTree(cah.getClusters());
}

void MainWindow::makeTree(QList<Cluster> clusters)
{
	resultWidget->clear();
	for(int i = 0; i < clusters.size(); ++i) {
		QStringList args;
		QTreeWidgetItem *item;
		args << clusters[i].getName();
		args << clusters[i].getValues();
		args << QString::number(clusters[i].getDst(), 'f', getPrec());

		item = new QTreeWidgetItem(args);
		addChilds(item, clusters[i].getChilds());
		resultWidget->addTopLevelItem(item);
		item->setExpanded(true);
		expandChilds(item);
	}


	resultWidget->resizeColumnToContents(0);
	resultWidget->resizeColumnToContents(1);
}

void MainWindow::expandChilds(QTreeWidgetItem *root) {
	for(int i = 0; i < root->childCount(); ++i) {
		expandChilds(root->child(i));
		root->setExpanded(true);
	}
}

void MainWindow::addChilds(QTreeWidgetItem *root, QList<Cluster> clusters) {
	if(!root || clusters.size() == 0)
		return;

	for(int i = 0; i < clusters.size(); ++i) {
		QStringList args;
		QTreeWidgetItem *item;
		args << clusters[i].getName();
		args << clusters[i].getValues();
		args << QString::number(clusters[i].getDst(), 'f', getPrec());

		item = new QTreeWidgetItem(args);
		addChilds(item, clusters[i].getChilds());
		root->addChild(item);
	}
}

void MainWindow::resizePond(const uint size)
{
	poidWidget->clear();
	poidWidget->setColumnCount(size);
	poidWidget->setRowCount(1);

	for(int i = 0; i < poidWidget->columnCount (); ++i) {
		QTableWidgetItem *item = poidWidget->item(0, i);

		if(item)
			item->setText(tr("1"));
		else {
			item = new QTableWidgetItem(tr("1"));
			item->setFlags(Qt::ItemIsEnabled|Qt::ItemIsEditable|Qt::ItemIsSelectable);
			poidWidget->setItem(0, i, item);
		}
	}
}

bool MainWindow::saveResult(const QString & fileName)
{
	QFile file(fileName);
	if (!file.open(QFile::WriteOnly | QFile::Text)) {
		QMessageBox::warning(this, tr("MatrixEditor"),
				     tr("Impossible d'crire %1:\n%2.").
				     arg(fileName).arg(file.errorString()));
		return false;
	}

	QTextStream out(&file);
	QApplication::setOverrideCursor(Qt::WaitCursor);

	QApplication::restoreOverrideCursor();

	return true;
}
